require "socket"
#on importe les fichier requis
puts "Lecture du fichier de configuration..."
require "conf.rb"
require "lib/Logger.rb"
require "lib/Com.rb"
$CO = 1 #le compteur pour les nom de fichier receptacle de mails
Logs = Logger.new("server.log",true) #on active le logger
Logs.write("info","Activation du serveur sur le port #{$PORT}")
server = TCPServer.new($HOSTNAME, $PORT) #on cre le socket
while true #un boucle infini pour attendre des connexion a l'infini
  Thread.start(server.accept) do |session| #si quelqun essais de se connecter on accepte et le traite dans un nouveau thread
    Logs.write("info","Connexion de #{session.peeraddr[3]}")
    com = Com.new(session) #on active la classe de communication
    com.send("220 #{$PORT} SMTP Server Ready")
    com.input
    com.send("250 #{$HOSTNAME}")
    from = com.input
    com.send("250 OK")
    to = com.input
    com.send("250 OK")
    com.input
    com.send("354 Start mail input; end with <CRLF>.<CRLF>")
    body = "" #on initialize le corp du mail
    while (tin = com.input) do   #puis on le remplis
      if tin == "." #tant qu'on ne rencontre pas de point seul (fin de message dans le protocole SMTP)
        break
      else
        body << "#{tin}\n" #c'est ici qu'on remplis la variable body
      end
    end
    com.send("250 OK")
    com.input
    com.send("221 Thanks")
    session.close
    File.open("send/mail#{$CO}.txt" , "w+") do |f| #on ecrit le contenu du mail dans un fichier
      f.write(body)
      Logs.write("info","MAIL #{$CO} RECU!")
      $CO += 1 #on incremente le compteur
    end
  end
  
end
